? ar
? copyandspawn.cc
? foo.patch
? Guidelines.txt
? io_stream-net_latest.diff
? io_stream-net_latest_Makefile.in.diff
? pavel20011206.patch
? Proprety.patch
? replaceself.patch
? setupfix.patch
? URLParser.cc
? URLParser.h
Index: choose.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/choose.cc,v
retrieving revision 2.79
diff -u -p -r2.79 choose.cc
--- choose.cc	2001/12/20 11:49:53	2.79
+++ choose.cc	2001/12/20 12:35:59
@@ -36,6 +36,7 @@ static const char *cvsid =
 #include <stdlib.h>
 #include <io.h>
 #include <ctype.h>
+#include <process.h>
 
 #include "dialog.h"
 #include "resource.h"
@@ -47,6 +48,7 @@ static const char *cvsid =
 #include "find.h"
 #include "filemanip.h"
 #include "io_stream.h"
+#include "propsheet.h"
 #include "choose.h"
 #include "category.h"
 
@@ -55,6 +57,8 @@ static const char *cvsid =
 #include "package_version.h"
 
 #include "port.h"
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
 
 #define alloca __builtin_alloca
 
@@ -1089,6 +1093,7 @@ dialog_proc (HWND h, UINT message, WPARA
       r.top += 2;
       r.bottom -= 2;
       create_listview (h, &r);
+
 #if 0
       load_dialog (h);
 #endif
@@ -1193,7 +1198,7 @@ scan_downloaded_files ()
 }
 
 void
-do_choose (HINSTANCE h)
+do_choose (HINSTANCE h, HWND owner)
 {
   int rv;
 
@@ -1217,9 +1222,9 @@ do_choose (HINSTANCE h)
   set_existence ();
   fill_missing_category ();
 
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_CHOOSE), 0, dialog_proc);
+  rv = DialogBox (h, MAKEINTRESOURCE (IDD_CHOOSE), owner, dialog_proc);
   if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+    fatal (owner, IDS_DIALOG_FAILED);
 
   log (LOG_BABBLE, "Chooser results...");
   packagedb db;
@@ -1302,4 +1307,63 @@ do_choose (HINSTANCE h)
 	}
 #endif
     }
+}
+
+#define WM_APP_START_CHOOSE        WM_APP+0
+#define WM_APP_CHOOSE_IS_FINISHED  WM_APP+1
+
+extern void
+do_choose (HINSTANCE h, HWND owner);
+
+void do_choose_thread(void *p)
+{
+	ChooserPage *cp;
+
+	cp = static_cast<ChooserPage*>(p);
+
+	do_choose(cp->GetInstance(), cp->GetHWND());
+
+	cp->PostMessage(WM_APP_CHOOSE_IS_FINISHED);
+
+	_endthread();
+}
+
+bool ChooserPage::Create()
+{
+  return PropertyPage::Create(IDD_CHOOSER);
+}
+
+void ChooserPage::OnActivate()
+{
+  GetOwner()->SetButtons(0);
+  PostMessage(WM_APP_START_CHOOSE);
+}
+
+bool ChooserPage::OnMessageApp(UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+	switch(uMsg)
+	{
+	case WM_APP_START_CHOOSE:
+		{
+			// Start the chooser thread.
+			_beginthread(do_choose_thread, 0, this);
+			break;
+		}
+	case WM_APP_CHOOSE_IS_FINISHED:
+		{
+			if(next_dialog == 0)
+			{
+				// Cancel
+				GetOwner()->PressButton(PSBTN_CANCEL);
+				break;
+			}
+			Progress.SetActivateTask(WM_APP_START_DOWNLOAD);
+			GetOwner()->SetActivePageByID(IDD_INSTATUS);
+			break;
+		}
+	default:
+		return false;
+		break;
+	}
+	return true;
 }
Index: choose.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/choose.h,v
retrieving revision 2.9
diff -u -p -r2.9 choose.h
--- choose.h	2001/12/20 11:49:53	2.9
+++ choose.h	2001/12/20 12:35:59
@@ -16,6 +16,8 @@
 #ifndef _CHOOSE_H_
 #define _CHOOSE_H_
 
+#include "proppage.h"
+
 class Category;
 class packagemeta;
 
@@ -195,5 +197,18 @@ private:
   void set_headers ();
   void init_headers (HDC dc);
 };
+
+class ChooserPage : public PropertyPage
+{
+public:
+	ChooserPage() {};
+	virtual ~ChooserPage() {};
+	
+	virtual bool OnMessageApp(UINT uMsg, WPARAM wParam, LPARAM lParam);
+	
+	bool Create();
+	virtual void OnActivate();
+};
+
 #endif /* __cplusplus */
 #endif /* _CHOOSE_H_ */
Index: cistring.cc
===================================================================
RCS file: cistring.cc
diff -N cistring.cc
--- /dev/null	Tue May  5 13:32:27 1998
+++ cistring.cc	Thu Dec 20 04:35:59 2001
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// Yep, another string class
+
+#include "cistring.h"
+#include <stdlib.h>
+
+DWORD
+cistring::Format (UINT i, ...)
+{
+  TCHAR FormatStringBuffer[256];
+  TCHAR *Buff;
+  va_list arglist;
+  DWORD numchars;
+
+  // Get the string from the stringtable (FormatMessage() can only work with
+  // literal strings or *message*table entries, which are different for some
+  // inexplicable reason).
+  LoadString (GetModuleHandle (NULL), i, FormatStringBuffer, 256);
+
+  va_start (arglist, i);
+  numchars =::
+    FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER |
+		   FORMAT_MESSAGE_FROM_STRING, FormatStringBuffer, i, 0,
+		   (LPTSTR) & Buff, 0, &arglist);
+  va_end (arglist);
+
+  if (numchars == 0)
+    {
+      // Something went wrong.
+      return 0;
+    }
+
+  buffer = new TCHAR[(numchars + 1) * sizeof (TCHAR)];
+  memcpy (buffer, Buff, (numchars + 1) * sizeof (TCHAR));
+  LocalFree (Buff);
+
+  return numchars;
+}
Index: cistring.h
===================================================================
RCS file: cistring.h
diff -N cistring.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ cistring.h	Thu Dec 20 04:35:59 2001
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// Yep, another string class
+
+#include <windows.h>
+
+class cistring
+{
+  TCHAR *buffer;
+public:
+    cistring ()
+  {
+    buffer = NULL;
+  };
+  cistring (const TCHAR * s);
+  ~cistring ()
+  {
+    if (buffer != NULL)
+      delete[]buffer;
+  };
+
+  const TCHAR *c_str ()
+  {
+    return buffer;
+  };
+
+  DWORD Format (UINT i, ...);
+};
Index: desktop.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/desktop.cc,v
retrieving revision 2.19
diff -u -p -r2.19 desktop.cc
--- desktop.cc	2001/12/20 11:49:53	2.19
+++ desktop.cc	2001/12/20 12:35:59
@@ -48,6 +48,8 @@ static const char *cvsid =
 #include "package_meta.h"
 #include "package_version.h"
 
+#include "desktop.h"
+
 static OSVERSIONINFO verinfo;
 
 /* Lines starting with '@' are conditionals - include 'N' for NT,
@@ -444,56 +446,48 @@ dialog_cmd (HWND h, int id, HWND hwndctl
       save_dialog (h);
       check_if_enable_next (h);
       break;
-
-    case IDOK:
-      save_dialog (h);
-      do_desktop_setup ();
-      NEXT (IDD_S_POSTINSTALL);
-      break;
-
-    case IDC_BACK:
-      save_dialog (h);
-      NEXT (IDD_CHOOSE);
-      break;
-
-    case IDCANCEL:
-      NEXT (0);
-      break;
     }
   return 0;
 }
 
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
+bool
+DesktopSetupPage::Create ()
 {
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      load_dialog (h);
-      return FALSE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
+  return PropertyPage::Create (NULL, dialog_cmd, IDD_DESKTOP);
 }
 
 void
-do_desktop (HINSTANCE h)
+DesktopSetupPage::OnInit ()
 {
+  // FIXME: This CoInitialize() feels like it could be moved to startup in main.cc.
   CoInitialize (NULL);
-
   verinfo.dwOSVersionInfoSize = sizeof (verinfo);
   GetVersionEx (&verinfo);
-
   root_desktop =
     check_desktop ("Cygwin", backslash (cygpath ("/cygwin.bat", 0)));
   root_menu =
     check_startmenu ("Cygwin Bash Shell",
 		     backslash (cygpath ("/cygwin.bat", 0)));
+  load_dialog (GetHWND ());
+}
 
-  int rv = 0;
+long
+DesktopSetupPage::OnBack ()
+{
+  HWND h = GetHWND ();
+  save_dialog (h);
+  NEXT (IDD_CHOOSE);
+  return IDD_CHOOSER;
+}
+
+bool
+DesktopSetupPage::OnFinish ()
+{
+  HWND h = GetHWND ();
+  save_dialog (h);
+  do_desktop_setup ();
+  NEXT (IDD_S_POSTINSTALL);
+  do_postinstall (GetInstance (), h);
 
-  rv = DialogBox (h, MAKEINTRESOURCE (IDD_DESKTOP), 0, dialog_proc);
-  if (rv == -1)
-    fatal (IDS_DIALOG_FAILED);
+  return true;
 }
Index: desktop.h
===================================================================
RCS file: desktop.h
diff -N desktop.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ desktop.h	Thu Dec 20 04:35:59 2001
@@ -0,0 +1,41 @@
+#ifndef CINSTALL_DESKTOP_H
+#define CINSTALL_DESKTOP_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the DesktopSetupPage class.  Allows selection
+// of "create desktop icon" and "add to start menu".
+
+#include "proppage.h"
+
+class DesktopSetupPage:public PropertyPage
+{
+public:
+  DesktopSetupPage ()
+  {
+  };
+  virtual ~ DesktopSetupPage ()
+  {
+  };
+
+  bool Create ();
+
+  virtual void OnInit ();
+  virtual bool OnFinish ();
+  virtual long OnBack ();
+};
+
+#endif // CINSTALL_DESKTOP_H
Index: dialog.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/dialog.h,v
retrieving revision 2.4
diff -u -p -r2.4 dialog.h
--- dialog.h	2001/11/13 01:49:31	2.4
+++ dialog.h	2001/12/20 12:35:59
@@ -22,7 +22,7 @@ extern int next_dialog;
 /* either "nothing to do" or "setup complete" or something like that */
 extern int exit_msg;
 
-#define D(x) void x(HINSTANCE _h)
+#define D(x) void x(HINSTANCE _h, HWND owner)
 
 /* prototypes for all the do_* functions (most called by main.cc) */
 
Index: download.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/download.cc,v
retrieving revision 2.18
diff -u -p -r2.18 download.cc
--- download.cc	2001/12/20 11:49:53	2.18
+++ download.cc	2001/12/20 12:35:59
@@ -25,6 +25,7 @@ static const char *cvsid =
 
 #include <stdio.h>
 #include <unistd.h>
+#include <process.h>
 
 #include "resource.h"
 #include "msg.h"
@@ -47,6 +48,9 @@ static const char *cvsid =
 
 #include "rfc1738.h"
 
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
+
 /* 0 on failure
  */
 static int
@@ -95,7 +99,7 @@ check_for_cached (packagesource & pkgsou
 
 /* download a file from a mirror site to the local cache. */
 static int
-download_one (packagesource & pkgsource)
+download_one (packagesource & pkgsource, HWND owner)
 {
   if (check_for_cached (pkgsource) && source != IDC_SOURCE_DOWNLOAD)
     return 0;
@@ -106,14 +110,15 @@ download_one (packagesource & pkgsource)
   for (size_t n = 1; n <= pkgsource.sites.number () && !success; n++)
     {
       const char *local = concat (local_dir, "/",
-				  rfc1738_escape_part (pkgsource.sites[n]->key), "/",
+				  rfc1738_escape_part (pkgsource.sites[n]->
+						       key), "/",
 				  pkgsource.Canonical (), 0);
       io_stream::mkpath_p (PATH_TO_FILE, concat ("file://", local, 0));
 
       if (get_url_to_file
 	  (concat
 	   (pkgsource.sites[n]->key, "/", pkgsource.Canonical (), 0),
-	   concat (local, ".tmp", 0), pkgsource.size))
+	   concat (local, ".tmp", 0), pkgsource.size, owner))
 	{
 	  /* FIXME: note new source ? */
 	  continue;
@@ -146,8 +151,8 @@ download_one (packagesource & pkgsource)
   return 1;
 }
 
-void
-do_download (HINSTANCE h)
+static void
+do_download_thread (HINSTANCE h, HWND owner)
 {
   int errors = 0;
   total_download_bytes = 0;
@@ -157,19 +162,19 @@ do_download (HINSTANCE h)
   /* calculate the amount needed */
   for (size_t n = 1; n < db.packages.number (); n++)
     {
-      packagemeta &pkg = * db.packages[n];
+      packagemeta & pkg = *db.packages[n];
       if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
-      {
-	packageversion *version = pkg.desired;
-	if (!
-	    (check_for_cached (version->bin)
-	     && source != IDC_SOURCE_DOWNLOAD))
-	  total_download_bytes += version->bin.size;
-	if (!
-	    (check_for_cached (version->src)
-	     && source != IDC_SOURCE_DOWNLOAD))
-	  total_download_bytes += version->src.size;
-      }
+	{
+	  packageversion *version = pkg.desired;
+	  if (!
+	      (check_for_cached (version->bin)
+	       && source != IDC_SOURCE_DOWNLOAD) && pkg.desired->binpicked)
+	    total_download_bytes += version->bin.size;
+	  if (!
+	      (check_for_cached (version->src)
+	       && source != IDC_SOURCE_DOWNLOAD) && pkg.desired->srcpicked)
+	    total_download_bytes += version->src.size;
+	}
     }
 
   /* and do the download. FIXME: This here we assign a new name for the cached version
@@ -177,28 +182,28 @@ do_download (HINSTANCE h)
    */
   for (size_t n = 1; n < db.packages.number (); n++)
     {
-      packagemeta &pkg = * db.packages[n];
-    if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
-      {
-	int e = 0;
-	packageversion *version = pkg.desired;
-	if (version->binpicked)
-	  e += download_one (version->bin);
-	if (version->srcpicked)
-	  e += download_one (version->src);
-	errors += e;
+      packagemeta & pkg = *db.packages[n];
+      if (pkg.desired && (pkg.desired->srcpicked || pkg.desired->binpicked))
+	{
+	  int e = 0;
+	  packageversion *version = pkg.desired;
+	  if (version->binpicked)
+	    e += download_one (version->bin, owner);
+	  if (version->srcpicked)
+	    e += download_one (version->src, owner);
+	  errors += e;
 #if 0
-	if (e)
-	  pkg->action = ACTION_ERROR;
+	  if (e)
+	    pkg->action = ACTION_ERROR;
 #endif
-      }
+	}
     }
 
   dismiss_url_status_dialog ();
 
   if (errors)
     {
-      if (yesno (IDS_DOWNLOAD_INCOMPLETE) == IDYES)
+      if (yesno (owner, IDS_DOWNLOAD_INCOMPLETE) == IDYES)
 	{
 	  next_dialog = IDD_SITE;
 	  return;
@@ -215,4 +220,29 @@ do_download (HINSTANCE h)
     }
   else
     next_dialog = IDD_S_INSTALL;
+}
+
+static void
+do_download_reflector (void *p)
+{
+  HANDLE *context;
+  context = (HANDLE *) p;
+
+  do_download_thread ((HINSTANCE) context[0], (HWND) context[1]);
+
+  // Tell the progress page that we're done downloading
+  Progress.PostMessage (WM_APP_DOWNLOAD_THREAD_COMPLETE, 0, next_dialog);
+
+  _endthread ();
+}
+
+static HANDLE context[2];
+
+void
+do_download (HINSTANCE h, HWND owner)
+{
+  context[0] = h;
+  context[1] = owner;
+
+  _beginthread (do_download_reflector, 0, context);
 }
Index: fromcwd.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/fromcwd.cc,v
retrieving revision 2.16
diff -u -p -r2.16 fromcwd.cc
--- fromcwd.cc	2001/12/20 11:49:53	2.16
+++ fromcwd.cc	2001/12/20 12:36:00
@@ -118,7 +118,7 @@ check_ini (char *path, unsigned int fsiz
 }
 
 void
-do_fromcwd (HINSTANCE h)
+do_fromcwd (HINSTANCE h, HWND owner)
 {
   found_ini = true;
   find (".", check_ini);
Index: geturl.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/geturl.cc,v
retrieving revision 2.15
diff -u -p -r2.15 geturl.cc
--- geturl.cc	2001/12/02 03:25:11	2.15
+++ geturl.cc	2001/12/20 12:36:00
@@ -43,119 +43,33 @@ static const char *cvsid =
 #include "diskfull.h"
 #include "mount.h"
 
-static HWND gw_dialog = 0;
-static HWND gw_url = 0;
-static HWND gw_rate = 0;
-static HWND gw_progress = 0;
-static HWND gw_pprogress = 0;
-static HWND gw_iprogress = 0;
-static HWND gw_progress_text = 0;
-static HWND gw_pprogress_text = 0;
-static HWND gw_iprogress_text = 0;
-static HANDLE init_event;
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
+
 static int max_bytes = 0;
 static int is_local_install = 0;
 
 int total_download_bytes = 0;
 int total_download_bytes_sofar = 0;
 
-static BOOL
-dialog_cmd (HWND h, int id, HWND hwndctl, UINT code)
-{
-  switch (id)
-    {
-    case IDCANCEL:
-      exit_setup (0);
-    }
-  return 0;
-}
-
-static BOOL CALLBACK
-dialog_proc (HWND h, UINT message, WPARAM wParam, LPARAM lParam)
-{
-  switch (message)
-    {
-    case WM_INITDIALOG:
-      gw_dialog = h;
-      gw_url = GetDlgItem (h, IDC_DLS_URL);
-      gw_rate = GetDlgItem (h, IDC_DLS_RATE);
-      gw_progress = GetDlgItem (h, IDC_DLS_PROGRESS);
-      gw_pprogress = GetDlgItem (h, IDC_DLS_PPROGRESS);
-      gw_iprogress = GetDlgItem (h, IDC_DLS_IPROGRESS);
-      gw_progress_text = GetDlgItem (h, IDC_DLS_PROGRESS_TEXT);
-      gw_pprogress_text = GetDlgItem (h, IDC_DLS_PPROGRESS_TEXT);
-      gw_iprogress_text = GetDlgItem (h, IDC_DLS_IPROGRESS_TEXT);
-      SetEvent (init_event);
-      return TRUE;
-    case WM_COMMAND:
-      return HANDLE_WM_COMMAND (h, wParam, lParam, dialog_cmd);
-    }
-  return FALSE;
-}
-
-static WINAPI DWORD
-dialog (void *)
-{
-  MSG m;
-  HWND local_gw_dialog =
-    CreateDialog (hinstance, MAKEINTRESOURCE (IDD_DLSTATUS),
-		  0, dialog_proc);
-  ShowWindow (local_gw_dialog, SW_SHOWNORMAL);
-  UpdateWindow (local_gw_dialog);
-  while (GetMessage (&m, 0, 0, 0) > 0)
-    {
-      TranslateMessage (&m);
-      DispatchMessage (&m);
-    }
-  return 0;
-}
-
 static DWORD start_tics;
 
 static void
-init_dialog (char const *url, int length)
+init_dialog (char const *url, int length, HWND owner)
 {
   if (is_local_install)
     return;
-  if (gw_dialog == 0)
-    {
-      DWORD tid;
-      HANDLE thread;
-      init_event = CreateEvent (0, 0, 0, 0);
-      thread = CreateThread (0, 0, dialog, 0, 0, &tid);
-      WaitForSingleObject (init_event, 1000);
-      CloseHandle (init_event);
-      SendMessage (gw_progress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-      SendMessage (gw_pprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-      SendMessage (gw_iprogress, PBM_SETRANGE, 0, MAKELPARAM (0, 100));
-    }
+
   char const *sl = url;
   char const *cp;
   for (cp = url; *cp; cp++)
     if (*cp == '/' || *cp == '\\' || *cp == ':')
       sl = cp + 1;
   max_bytes = length;
-  SetWindowText (gw_url, sl);
-  SetWindowText (gw_rate, "Connecting...");
-  SendMessage (gw_progress, PBM_SETPOS, (WPARAM) 0, 0);
-  ShowWindow (gw_progress, (length > 0) ? SW_SHOW : SW_HIDE);
-  if (length > 0)
-    SetWindowText (gw_progress_text, "Package");
-  else
-    SetWindowText (gw_progress_text, "       ");
-  ShowWindow (gw_pprogress, (total_download_bytes > 0) ? SW_SHOW : SW_HIDE);
-  if (total_download_bytes > 0)
-    {
-      SetWindowText (gw_pprogress_text, "Total");
-      SetWindowText (gw_iprogress_text, "Disk");
-    }
-  else
-    {
-      SetWindowText (gw_pprogress_text, "     ");
-      SetWindowText (gw_iprogress_text, "    ");
-    }
-  ShowWindow (gw_iprogress, (total_download_bytes > 0) ? SW_SHOW : SW_HIDE);
-  ShowWindow (gw_dialog, SW_SHOWNORMAL);
+  Progress.SetText1 ("Downloading...");
+  Progress.SetText2 (sl);
+  Progress.SetText3 ("Connecting...");
+  Progress.SetBar1 (0);
   start_tics = GetTickCount ();
 }
 
@@ -166,7 +80,7 @@ progress (int bytes)
   if (is_local_install)
     return;
   static char buf[100];
-  int kbps;
+  double kbps;
   static unsigned int last_tics = 0;
   DWORD tics = GetTickCount ();
   if (tics == start_tics)	// to prevent division by zero
@@ -175,36 +89,31 @@ progress (int bytes)
     return;
   last_tics = tics;
 
-  kbps = bytes / (tics - start_tics);
-  ShowWindow (gw_progress, (max_bytes > 0) ? SW_SHOW : SW_HIDE);
-  ShowWindow (gw_pprogress, (total_download_bytes > 0) ? SW_SHOW : SW_HIDE);
-  ShowWindow (gw_iprogress, (total_download_bytes > 0) ? SW_SHOW : SW_HIDE);
-  if (max_bytes > 100)
-    {
-      int perc = bytes / (max_bytes / 100);
-      SendMessage (gw_progress, PBM_SETPOS, (WPARAM) perc, 0);
-      sprintf (buf, "%3d %%  (%dk/%dk)  %d kb/s\n",
+  kbps = ((double) bytes) / (double) (tics - start_tics);
+  if (max_bytes > 0)
+    {
+      int perc = (int) (100.0 * ((double) bytes) / (double) max_bytes);
+      Progress.SetBar1 (bytes, max_bytes);
+      sprintf (buf, "%3d %%  (%dk/%dk)  %2.1f kb/s\n",
 	       perc, bytes / 1000, max_bytes / 1000, kbps);
       if (total_download_bytes > 0)
 	{
-	  int totalperc =
-	    (total_download_bytes_sofar +
-	     bytes) / (total_download_bytes / 100);
-	  SendMessage (gw_pprogress, PBM_SETPOS, (WPARAM) totalperc, 0);
+	  Progress.SetBar2 (total_download_bytes_sofar + bytes,
+			    total_download_bytes);
 	}
     }
   else
-    sprintf (buf, "%d  %d kb/s\n", bytes, kbps);
+    sprintf (buf, "%d  %2.1f kb/s\n", bytes, kbps);
 
-  SetWindowText (gw_rate, buf);
+  Progress.SetText3 (buf);
 }
 
 io_stream *
-get_url_to_membuf (char const *_url)
+get_url_to_membuf (char const *_url, HWND owner)
 {
   log (LOG_BABBLE, "get_url_to_membuf %s", _url);
   is_local_install = (source == IDC_SOURCE_CWD);
-  init_dialog (_url, 0);
+  init_dialog (_url, 0, owner);
   NetIO *n = NetIO::open (_url);
   if (!n || !n->ok ())
     {
@@ -254,9 +163,9 @@ get_url_to_membuf (char const *_url)
 }
 
 char *
-get_url_to_string (char const *_url)
+get_url_to_string (char const *_url, HWND owner)
 {
-  io_stream *stream = get_url_to_membuf (_url);
+  io_stream *stream = get_url_to_membuf (_url, owner);
   if (!stream)
     return 0;
   size_t bytes = stream->get_size ();
@@ -264,10 +173,11 @@ get_url_to_string (char const *_url)
     {
       /* zero length, or error retrieving length */
       delete stream;
-      log (LOG_BABBLE, "get_url_to_string(): couldn't retrieve buffer size, or zero length buffer");
+      log (LOG_BABBLE,
+	   "get_url_to_string(): couldn't retrieve buffer size, or zero length buffer");
       return 0;
     }
-  char *rv = new char [bytes + 1];
+  char *rv = new char[bytes + 1];
   if (!rv)
     {
       delete stream;
@@ -276,22 +186,22 @@ get_url_to_string (char const *_url)
     }
   /* membufs are quite safe */
   stream->read (rv, bytes);
-  rv [bytes] = '\0';
+  rv[bytes] = '\0';
   delete stream;
   return rv;
 }
 
 int
 get_url_to_file (char *_url, char *_filename, int expected_length,
-		 BOOL allow_ftp_auth)
+		 HWND owner, BOOL allow_ftp_auth)
 {
   log (LOG_BABBLE, "get_url_to_file %s %s", _url, _filename);
   if (total_download_bytes > 0)
     {
       int df = diskfull (get_root_dir ());
-      SendMessage (gw_iprogress, PBM_SETPOS, (WPARAM) df, 0);
+      Progress.SetBar3 (df);
     }
-  init_dialog (_url, expected_length);
+  init_dialog (_url, expected_length, owner);
 
   remove (_filename);		/* but ignore errors */
 
@@ -309,7 +219,7 @@ get_url_to_file (char *_url, char *_file
       const char *err = strerror (errno);
       if (!err)
 	err = "(unknown error)";
-      fatal (IDS_ERR_OPEN_WRITE, _filename, err);
+      fatal (owner, IDS_ERR_OPEN_WRITE, _filename, err);
     }
 
   if (n->file_size)
@@ -338,15 +248,16 @@ get_url_to_file (char *_url, char *_file
   if (total_download_bytes > 0)
     {
       int df = diskfull (get_root_dir ());
-      SendMessage (gw_iprogress, PBM_SETPOS, (WPARAM) df, 0);
+      Progress.SetBar3 (df);
     }
 
   return 0;
 }
 
+// FIXME: I think this can go now, I don't think anything calls it.
 void
 dismiss_url_status_dialog ()
 {
-  if (!is_local_install)
-    ShowWindow (gw_dialog, SW_HIDE);
+  //if (!is_local_install)
+  //ShowWindow (gw_dialog, SW_HIDE);
 }
Index: geturl.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/geturl.h,v
retrieving revision 2.4
diff -u -p -r2.4 geturl.h
--- geturl.h	2001/12/02 03:25:11	2.4
+++ geturl.h	2001/12/20 12:36:00
@@ -21,8 +21,8 @@ extern int total_download_bytes_sofar;
 
 class io_stream;
 
-io_stream *get_url_to_membuf (char const *);
-char *get_url_to_string (char const *);
+io_stream *get_url_to_membuf (char const *, HWND owner);
+char *get_url_to_string (char const *, HWND owner);
 int get_url_to_file (char *_url, char *_filename, int expected_size,
-		     BOOL allow_ftp_auth = FALSE);
+		     HWND owner, BOOL allow_ftp_auth = FALSE);
 void dismiss_url_status_dialog ();
Index: ini.cc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/ini.cc,v
retrieving revision 2.15
diff -u -p -r2.15 ini.cc
--- ini.cc	2001/12/03 22:22:09	2.15
+++ ini.cc	2001/12/20 12:36:00
@@ -28,6 +28,7 @@ static const char *cvsid =
 #include <stdio.h>
 #include <stdlib.h>
 #include <stdarg.h>
+#include <process.h>
 
 #include "ini.h"
 #include "resource.h"
@@ -45,6 +46,9 @@ static const char *cvsid =
 
 #include "io_stream.h"
 
+#include "threebar.h"
+extern ThreeBarProgressPage Progress;
+
 unsigned int setup_timestamp = 0;
 char *setup_version = 0;
 
@@ -59,50 +63,54 @@ static int local_ini;
 static void
 find_routine (char *path, unsigned int fsize)
 {
-  if (!strstr (path, "/setup.ini") )
+  if (!strstr (path, "/setup.ini"))
     return;
-  io_stream *ini_file = io_stream::open (concat ("file://", local_dir,"/", path, 0), "rb");
+  io_stream *ini_file =
+    io_stream::open (concat ("file://", local_dir, "/", path, 0), "rb");
   if (!ini_file)
     {
-    note (IDS_SETUPINI_MISSING, path);
-    return;
+      note (NULL, IDS_SETUPINI_MISSING, path);
+      return;
     }
 
   /* FIXME: only use most recent copy */
   setup_timestamp = 0;
   setup_version = 0;
 
-  ini_init (ini_file, concat ("file://", local_dir,"/", path, 0));
+  ini_init (ini_file, concat ("file://", local_dir, "/", path, 0));
 
   /*yydebug = 1; */
 
   if (yyparse () || error_count > 0)
-    MessageBox (0, error_buf, error_count == 1 ? "Parse Error" : "Parse Errors", 0);
+    MessageBox (0, error_buf,
+		error_count == 1 ? "Parse Error" : "Parse Errors", 0);
   else
     local_ini++;
 }
 
 static int
-do_local_ini ()
+do_local_ini (HWND owner)
 {
   local_ini = 0;
   find (local_dir, find_routine);
-  return local_ini; 
+  return local_ini;
 }
 
 static int
-do_remote_ini ()
+do_remote_ini (HWND owner)
 {
   size_t ini_count = 0;
+
   for (size_t n = 1; n <= site_list.number (); n++)
     {
       io_stream *ini_file =
-	get_url_to_membuf (concat (site_list[n]->url, "/setup.ini", 0));
+	get_url_to_membuf (concat (site_list[n]->url, "/setup.ini", 0),
+			   owner);
       dismiss_url_status_dialog ();
 
       if (!ini_file)
 	{
-	  note (IDS_SETUPINI_MISSING, site_list[n]->url);
+	  note (owner, IDS_SETUPINI_MISSING, site_list[n]->url);
 	  continue;
 	}
 
@@ -139,14 +147,14 @@ do_remote_ini ()
   return ini_count;
 }
 
-void
-do_ini (HINSTANCE h)
+static void
+do_ini_thread (HINSTANCE h, HWND owner)
 {
   size_t ini_count = 0;
   if (source == IDC_SOURCE_CWD)
-    ini_count = do_local_ini ();
+    ini_count = do_local_ini (owner);
   else
-    ini_count = do_remote_ini ();
+    ini_count = do_remote_ini (owner);
 
   if (ini_count == 0)
     {
@@ -171,7 +179,7 @@ do_ini (HINSTANCE h)
 	  if (old_timestamp && setup_timestamp
 	      && (old_timestamp > setup_timestamp))
 	    {
-	      int yn = yesno (IDS_OLD_SETUPINI);
+	      int yn = yesno (owner, IDS_OLD_SETUPINI);
 	      if (yn == IDNO)
 		exit_setup (1);
 	    }
@@ -197,11 +205,37 @@ do_ini (HINSTANCE h)
       char *ini_version = canonicalize_version (setup_version);
       char *our_version = canonicalize_version (version);
       if (strcmp (our_version, ini_version) < 0)
-	note (IDS_OLD_SETUP_VERSION, version, setup_version);
+	note (owner, IDS_OLD_SETUP_VERSION, version, setup_version);
     }
+
+  next_dialog = IDD_CHOOSER;
+}
+
+static void
+do_ini_thread_reflector (void *p)
+{
+  HANDLE *context;
+  context = (HANDLE *) p;
+
+  do_ini_thread ((HINSTANCE) context[0], (HWND) context[1]);
+
+  // Tell the progress page that we're done downloading
+  Progress.PostMessage (WM_APP_SETUP_INI_DOWNLOAD_COMPLETE, 0, next_dialog);
+
+  _endthread ();
+}
 
-  next_dialog = IDD_CHOOSE;
+static HANDLE context[2];
+
+void
+do_ini (HINSTANCE h, HWND owner)
+{
+  context[0] = h;
+  context[1] = owner;
+
+  _beginthread (do_ini_thread_reflector, 0, context);
 }
+
 
 extern int yylineno;
 
